//Thu Sat May  3 17:27:56 MET DST 1997 by Daniel Bhringer

// this is an example on how to use MiscString, MiscStringArray, MiscSplitView, MiscValueField and MiscFindPanel


// toDo:	 color icon
// 			 set MiscQueryField to last [query setIntValue:2000]; after each query


#define FILENAME "lexirom"


#import "AppDelegate.h"
#import "MiscString.Levenstein.h"

#import <misckit/MiscValueField.h>


@implementation NXBrowser(SafetyNet)
- selectText: sender
{	return self;
}
@end

@interface Text(StreamAddition)
- setFromRichText:(const char*) theStr replace:(BOOL) doReplac;
@end
@implementation Text(StreamAddition)
- setFromRichText:(const char*) theStr replace:(BOOL) doReplac
{	NXStream *stream;
	vm_address_t tmpMem;
	int len=strlen(theStr);
	if(!len || !theStr)
	{	[window disableFlushWindow];
		[[self selectAll:self] delete:self];
// now delete most of the tabs
		[window reenableFlushWindow];
		return self;
	}
	vm_allocate(task_self(),&tmpMem,len,TRUE);
	memcpy((void*)tmpMem,theStr,len);
	stream=NXOpenMemory((void*)tmpMem,len,NX_READONLY);
	[window disableFlushWindow];
	[window disableDisplay];
	if(doReplac) [self readRichText:stream];
	else
	{	[self setSel:[self textLength]:[self textLength]];
		[self replaceSelWithRichText:stream];
	}
	[self setSel:0:0];
	[self calcLine];
if(![self textLength]) [self setParaStyle:[self defaultParaStyle]];
	[[window reenableDisplay] display];
	[window reenableFlushWindow];
	NXCloseMemory(stream,NX_FREEBUFFER);
	return self;
}
@end

// doublefish override (Hidden and private)
@interface DoublefishText:Text
{}
@end
@implementation DoublefishText

- mouseDown:(NXEvent *)theEvent;
{	[super mouseDown:theEvent];
	if(theEvent->data.mouse.click == 2 && (theEvent->flags & NX_COMMANDMASK))
	{	[delegate didCmdDoubleClick:self];
	}
	return self;
}

@end

@interface Text(DExtension)
-(char*) stringValue;
- becomeClass:aClass;
@end
@implementation Text(DExtension)
- becomeClass:aClass
{	self->isa = aClass;
	return self;
}
-(char*) stringValue
{	int	  theLen=[self textLength];
	char *buf=malloc(theLen+1);
	[self getSubstring:buf start:0 length:theLen+1];
	buf[theLen]=0;
	return buf;
}
-(char*) selectedTextAsCopy
{	int	  theLen=spN.cp-sp0.cp;
	char *buf=malloc(theLen+1);
	[self getSubstring:buf start:sp0.cp length:theLen];
	buf[theLen]=0;
	return buf;
}

@interface MiscValueField(DExtension)
@end
@implementation MiscValueField(DExtension)

- textDidEnd:(Text*) textObject endChar:(unsigned short)whyEnd
{	if([self isEditable] && whyEnd)
	{	if(stringList)
		{	char *buf=[textObject stringValue];
			[stringList insertString:buf at:0];
			[self setStringList:stringList];
			[self setEditable:YES];
			free(buf);
		}
	} [super textDidEnd:textObject endChar:whyEnd];
	return self;
}
@end

@interface MiscString (SubfileLoading)
- loadFromFile:(const char *)fileName start:(unsigned int) start length:(unsigned int) len;
- setBytes:(const char *)ptr n:(int)n;
@end
@implementation MiscString (SubfileLoading)
- setBytes:(const char *)ptr n:(int)n
{	[self setStringValue:""];
	[self cat:ptr n:n];
	return self;
}
- loadFromFile:(const char *)fileName start:(unsigned int) start length:(unsigned int) len
{	int theFile;
	struct stat fileInfo;

	if (!fileName || stat(fileName, &fileInfo) ||
		!(theFile = open(fileName, O_RDONLY)))
	{	return nil;
	}
	if (fileInfo.st_size >= start+len)
	{  	[self allocateBuffer:len]; // make sure we're big enough
		lseek(theFile,start,0);
		if (len != read(theFile, buffer, len))
		{	close(theFile);
			return nil;
		}
	} close(theFile);
	[self recalcLength];
	return self;
}
@end

@implementation AppDelegate

int	perlStrcmp(const char *a, const char *b)
{	for (; *a && *b && *a==*b; a++,b++);
	return (unsigned char)*a - (unsigned char)*b;
}

int	searchArrayStr(const char * *arr,const char *val,int arrSize,int *reallyFound)
{	int	min=0,max=arrSize,mid=0,c=-1;

	while (min<=max && (c=perlStrcmp(arr[mid=(min+max)/2],val)))
		if (c<0) min=mid+1; else max=mid-1;
	if(reallyFound) (*reallyFound)=c? 0:1;
	return !c? mid: min;
}

unsigned long getFileSize(FILE *f)
{	unsigned long erg,curr;
	curr=ftell(f);
	fseek(f, 0, SEEK_END);
	erg=ftell(f);
	fseek(f, curr, SEEK_SET);
	return erg;
}


long longFromStr(const char *idxptr)
{
#if 1
	return (((unsigned char)idxptr[3])<<24)+	\
		   (((unsigned char)idxptr[2])<<16)+	\
		   (((unsigned char)idxptr[1])<< 8)+	\
		   (((unsigned char)idxptr[0])<< 0)	;
#else
	return (((unsigned char)idxptr[0])<<24)+	\
		   (((unsigned char)idxptr[1])<<16)+	\
		   (((unsigned char)idxptr[2])<< 8)+	\
		   (((unsigned char)idxptr[3])<< 0)	;
#endif
}
int shortFromStr(const char *idxptr)
{
#if 1
	short erg=(((unsigned char)idxptr[1])<<8)+	\
			  (((unsigned char)idxptr[0])<<0);
#else
	short erg=(((unsigned char)idxptr[0])<<8)+	\
			  (((unsigned char)idxptr[1])<<0);
#endif
	return erg;
}

int lookUpWord(char **arrptr,int arrcnt,const char *word,unsigned long *htmlOffset,unsigned long *htmlLength,char **foundWord,int *instance,id self)
{	char   *found;
	int		reallyFound=0,erg=1,idx;
	unsigned long offset=0;

	(*foundWord)=0L;
	idx=searchArrayStr(arrptr,word, arrcnt-1, &reallyFound);
	if(idx >= arrcnt || idx< 0) erg= 0;
	else
	{	if(strcmp(arrptr[idx],word)) return 0;
		while(idx> 0 && !strcmp(word, arrptr[idx-1])) idx--;
		for(; idx< arrcnt-1 && !strcmp(word, arrptr[idx]);idx++,(*instance)--)
		{	if(!(*instance))
			{	(*foundWord)=found=arrptr[idx];
				(*htmlOffset)=longFromStr(found+strlen(found)+1+0),
				(*htmlLength)=longFromStr(found+strlen(found)+1+4);
				break;
			}
		} if(idx+1< arrcnt-1 && !strcmp(word, arrptr[idx+1])) (*instance)=1; // signal that are more than one
		  else (*instance)=0;
	} return erg;
}

-(void) processForStearch:(MiscString *)search
{	[search toLower];
//	[search replaceEveryOccurrenceOfChar:'-' with:""];
	[search replaceEveryOccurrenceOfChar:'/' with:""];
	[search replaceEveryOccurrenceOfChar:' ' with:""];
	[search replaceEveryOccurrenceOfChar:'.' with:""];
	[search replaceEveryOccurrenceOfChar:',' with:""];
	[search replaceEveryOccurrenceOfChar:'*' with:""];
	[search replaceEveryOccurrenceOfChar:';' with:""];
	[search replaceEveryOccurrenceOfChar:':' with:""];
	[search replaceEveryOccurrenceOfChar:')' with:""];
	[search replaceEveryOccurrenceOfChar:']' with:""];
	[search replaceEveryOccurrenceOfChar:'' with:""];
	[search replaceEveryOccurrenceOfChar:'' with:"e"];
	[search replaceEveryOccurrenceOfChar:'' with:"e"];

}


//IXBTreeCursor emulation (bitte in Category auslagern)

-(BOOL) setKey:(const char *) theKey andLength:(unsigned) theLen instance:(int) instance last:(BOOL*) isLast
{	int		  erg;

	currOffset=currLen=0;
	(*isLast)=NO;
	if(erg=lookUpWord(flasharrptr,flashCnt,theKey,&currOffset,&currLen,&foundWord,&instance,self))
	{	(*isLast)=(BOOL)!instance;
	} 
	return erg;
}
-(BOOL) setKey:(const char *) theKey andLength:(unsigned) theLen
{	BOOL isLast,erg=[self setKey:theKey andLength:theLen instance:0 last:&isLast];
	return erg;
}
-(BOOL) getKey:(char **)ptr andLength:(int *)len
{	if(foundWord) { ptr[0]=foundWord,len[0]=strlen(foundWord); return YES; }
	else return NO;
	
}
-(long) readValue:(long **)ptr
{	static long tptr[2];
	tptr[0]=currOffset; tptr[1]=currLen;
	(*ptr)=tptr;
	return 8L;
}

// end:IXBTreeCursor emulation (bitte in Category auslagern)

-(void) logToText:(const char*) txt andDelete:(BOOL) doClear
{	MiscString *txtString=[[MiscString alloc] initFromFormat:"%s",txt];
	[text setDelegate:self];
	[window disableFlushWindow];[window disableDisplay];

	if(doClear)
	{	[text setText:""];
		[text setFromRichText:[txtString stringValue] replace:YES];
	} else
	{	[text setSel:[text textLength]:[text textLength]];[text replaceSel:"\n"];
		[text setFromRichText:[txtString stringValue] replace: NO];
	}
	[text selectAll:self];[text setSelFontFamily:"Times"];[text setSelFontSize:14.0];
	[text setEditable:NO];[text setSel:0:0];

	[[window reenableDisplay] display];
	[window reenableFlushWindow];
	[txtString free];

}

- lookUpString:(const char*) word
{	MiscString *search=[[MiscString alloc] initString:word];
	BOOL isLast;
	int	 inst=0;
	char	path[MAXPATHLEN+1];
	HashTable *doubletteHash=[[HashTable alloc] initKeyDesc:"i" valueDesc:"i"];

	[self processForStearch:search];
	[[NXBundle mainBundle] getPath:path forResource:FILENAME ofType:"dat.rtf"];

	if(!word || !strlen(word))
	{
	} else do
	{	if([self setKey:[search stringValue] andLength:[search length] instance:inst last:&isLast])
		{	long *tmpPtr=0,cnt;
			if(cnt=[self readValue:&tmpPtr])
			{	MiscString *str=[[MiscString alloc] init];
				if(![doubletteHash isKey:tmpPtr[0]])
				{	[str loadFromFile:path start:tmpPtr[0] length:tmpPtr[1]];
					[self logToText:[str stringValue] andDelete:!inst];[str free];
					[doubletteHash insertKey:tmpPtr[0] value:0];
				}
			}
		} else
		{	[text setText:"Unbekannter Begriff!"];
			NXBeep();
			break;
		} inst++;
	} while(!isLast);
	[search free];[doubletteHash  free];
	return self;
}

- lookUpString:(const char*) word logHistory:(BOOL) doLog
{	id erg;
	[historyArr insertString:word at:0];
	[field setStringList:historyArr];[field setEditable:YES];
	return [self lookUpString:word];

}

- defineWord:sender
{	[self lookUpString:[sender stringValue]];
	[sender selectText:self];
 	if(browserLoader)
	{	MiscString *selectionStr=[[MiscString alloc] initFromFormat:"/%s", [sender stringValue]];
		[browser setPath:[selectionStr stringValue]];
		[selectionStr free];
	} return self;
}
- didCmdDoubleClick:(Text*) theText
{	char *word=[theText selectedTextAsCopy];
	[self lookUpString:word logHistory:YES];
	free(word);
	return self;
}

// html-delegate methods

- showFile:(const char *) file atMarker:(const char *) markerName openInNewWin:(BOOL) flag
{	MiscString *search=[[MiscString alloc] initString:file];
	const char *p;
	[self processForStearch:search];

	[self lookUpString:[search stringValue] logHistory:YES];

	[search free];
	return self;
}

#define SEARCH_SCOPE 50

- textDidGetKeys:textObject isEmpty:(BOOL)flag
{	char *buf=[textObject stringValue];
	MiscString *str=[[MiscString alloc] initString:buf];
	int			reallyFound,i,bestScore=10000,peekScore,indexCurr;
	int startIndex=MAX(0,searchArrayStr(flasharrptr,[str stringValue], flashCnt-1, &reallyFound)-SEARCH_SCOPE);
	char	*ptrBest=0L;

	free(buf);
	[browser setDelegate:nil];
	if(browserLoader) [browserLoader free];
	browserLoader=[[MiscUniqueStringArray alloc] init];
	[browser setDelegate:browserLoader];
	if([str length] > 2)	// && [NXApp defaultIntValue:"Split"]
	{	for(i=startIndex,indexCurr=0;i< MIN(startIndex+SEARCH_SCOPE*2, flashCnt); i++)
		{	if((peekScore=[str levensteinDistanceFor:flasharrptr[i] cancelBeyond:strlen(flasharrptr[i])+5
									  matchSubstring:NO
								 	   caseSensitive:NO]) < 3 || strstr(flasharrptr[i],[str stringValue]))
			{	char *tmpPtr;
				[browserLoader addString:tmpPtr=NXCopyStringBuffer(flasharrptr[i])];
				if(peekScore< bestScore) bestScore=peekScore, ptrBest=tmpPtr;
				indexCurr++;
			}
		} [browser loadColumnZero];
		if(!bestScore)	// strings equal
		{	//[browser scrollToVisible:];
		}
	}
	[str free];
	return self;
}

unsigned long getNumOfWords(char *f)
{	return atol(f);
}

- loadIndex
{	char	path[MAXPATHLEN+1];

	if([[NXBundle mainBundle] getPath:path forResource:FILENAME ofType:"sortedidx"])
	{	FILE *flashidx=fopen(path,"rb");
		char *iterationPtr;
		int	  i,fsize=getFileSize(flashidx);

		flashidxbuf=(char* )malloc(fsize);
		fread(flashidxbuf, fsize,1,flashidx);
		fclose(flashidx);
		flashCnt= getNumOfWords(flashidxbuf);
		flasharrptr=(char**)malloc(sizeof(char*)*flashCnt);
		for(i=0, iterationPtr=strchr(flashidxbuf,'\n')+1; i < flashCnt;
							i++, iterationPtr+=strlen(iterationPtr)+10)
		{	flasharrptr[i]=iterationPtr;
		}
	} else
	{	NXLogError("Unable to locate %s in appwrapper",path);
		exit(2000);
	} return self;
}

void registerDefaults(void)
{	static NXDefaultsVector myDefaults=
	{	{"Split","0.0"},
		{NULL}
	};
	[NXApp registerDefaults:myDefaults];
}

- appDidInit:sender
{	registerDefaults();
	[self loadIndex];

	historyArr=[[MiscStringArray alloc] init];
	[historyArr addString:""];
	[field setStringList:historyArr];[field setEditable:YES];

	[text becomeClass:[DoublefishText class]];

	[window setFrameAutosaveName:"MainWin"];
	[browser removeFromSuperview];[scrol removeFromSuperview];
	[split setHorizontal:YES];[split addSubview:browser];[split addSubview:scrol];
	[split setDividersAutosaveName:"Split"];

	[window makeKeyAndOrderFront:self];

	[[NXApp appListener] setServicesDelegate:self];

	return self;
}

// provide service (in Makefile.preamble:OTHER_LDFLAGS)

- lookupWord:pasteboard userData:(const char *)userData error:(char **)msg
{	char	*data;
	int		length;

	[pasteboard types];		//obligatory
	if ([pasteboard readType:NXAsciiPboardType data:&data length:&length])
    {	MiscString *retStr=[[MiscString alloc] init];
		[retStr setBytes:data n:length];

		[self lookUpString:[retStr stringValueAndFree] logHistory:YES];

	} else *msg="No definition in lexirom possible - sorry.";
	return self;
}

@end
