// Mon Sep  2 12:09:44 MET DST 1996

#import <appkit/appkit.h>
#import "Text.HTMLExtensions.h"
#import "NXMarkerCell.h"

#define SEPERATOR_HEIGHT 12

@interface HRCell:Cell
{	Text	*text;
}
- initForText:(Text*) theText;
- free;
- calcCellSize:(NXSize *)theSize;
- highlight:(const NXRect *)cellFrame inView:controlView lit:(BOOL)flag;
-(BOOL)trackMouse:(NXEvent *)theEvent 
		   inRect:(const NXRect *)cellFrame 
		   ofView:controlView;
- drawInside: (const NXRect *)cellFrame inView:controlView;
@end

@interface TFTextFieldCell:TextFieldCell
{	NXCoord width;
	BOOL	afterDrag;
}
-(void) setWidth:(NXCoord)aWidth;
@end

@interface TFLinkCell:NXLinkCell
@end

@interface TFRadioCell:ButtonCell
{	List *collegues;
}
-(void) setCollegues:(List*) theCollegues;
- initInText:(Text*)view;
@end

@interface TFCheckCell:ButtonCell
{}
- initInText:(Text*)view;
@end

@interface TFButtonCell:ButtonCell
{}
- initInText:(Text*)view;
@end

@interface TFPopupCell:ButtonCell
{	PopUpList *popupList;
	Text	  *text;
	NXCoord width;
}
-(void) setPopupList:(PopUpList*) theList;
- initInText:(Text*)view;
-(void) setWidth:(NXCoord)aWidth;
@end


@interface TextBackgroundCell:Cell
{	NXImage *image;
}
- initFromImage:(NXImage*) theImg;

@end
@interface HTMLTextCell:Cell
{	NXSize size;
	id		delegate,_view;
	Text	*displayHelper;
	int		 columnsSpanning;
}
- initWithHTML:(const char*) theHTML inView: theView;
-(void) setSize:(NXSize*) aSize;
-(int)	columnsSpanning;

@end
@interface TFMatrixCell:Cell
{	Matrix *matrix;
}
- initWithMatrix:(Matrix *)matrix inView:controlView;
@end
