#import <misckit/misckit.h>


// error- tolerant comparing.

@interface MiscString(Levenstein)

//	returns minimum number of replaces, insertions, deletions, and swaps that would transform str to buffer.
//	(Rule of thumb: the greater the return value the more str and buffer differ).
//	0: str and buffer are identical
//	maxModifications: maximum for return value. (for better performance) 
//	ssFlag: sort of strstr() vs. strcmp()

-(unsigned) levensteinDistanceFor:(const char *) str cancelBeyond:(int) maxModifications
				   matchSubstring:(BOOL) ssFlag caseSensitive:(BOOL) caseFlag;

@end
