// Tue Oct 15 06:52:10 MET 1996 by Daniel Bhringer, All rights reserved

// this is not intended to be used in self-written Netscape derivatives (since it is not
// error-tolerant in any form, tables, backgroundimages and forms are in pre-alpha-state),
// but for rapid forms-prototyping and powerful intranet solutions. (EmbeddedHTML)
// also useful for creating rtfd-docs programmatically
// or showing helpfiles in NS4.x-apps

// note that background images are only partly supported (better do not use)
// and form-objects print in a smart way using the dingbats font

#import <appkit/appkit.h>
#import <misckit/misckit.h>

#import "HTMLCells.h"
#import "NXMarkerCell.h"

// recognized HTML-directives
// Warning: every END-token must exactly be below its start token!
typedef enum
{	HTML_HTML,
	HTML_ENDHTML,
	HTML_TITLE,
	HTML_ENDTITLE,
	HTML_HEAD,
	HTML_ENDHEAD,
	HTML_BODY,
	HTML_ENDBODY,
	HTML_H1,
	HTML_ENDH1,
	HTML_H2,
	HTML_ENDH2,
	HTML_H3,
	HTML_ENDH3,
	HTML_H4,
	HTML_ENDH4,
	HTML_H5,
	HTML_ENDH5,
	HTML_H6,
	HTML_ENDH6,
	HTML_HR,
	HTML_P,
	HTML_ENDP,
	HTML_STRONG,
	HTML_ENDSTRONG,
	HTML_DL,	// definitionlist
	HTML_ENDDL,
	HTML_DT,	// word to be defined
	HTML_DD,	// definition
	HTML_UL,	// unordered list
	HTML_ENDUL,
	HTML_LI,	// listitem
	HTML_ENDLI,
	HTML_OL,	// ordered list
	HTML_ENDOL,
	HTML_SAMP,	// contrast font
	HTML_ENDSAMP,	
	HTML_FORMSESSION,
	HTML_ENDFORMSESSION,
	HTML_FORMINPUT,
	HTML_IMG,
	HTML_EM,
	HTML_ENDEM,
	HTML_HREF,
	HTML_ENDHREF,
	HTML_NAME,
	HTML_SELECT,
	HTML_ENDSELECT,
	HTML_OPTION,
	HTML_ENDOPTION,
	HTML_CENTER,
	HTML_ENDCENTER,
	HTML_TABLE,
	HTML_ENDTABLE,
	HTML_TR,		// new tablerow
	HTML_ENDTR,		// end of new tablerow
	HTML_TH,		// tableheader
	HTML_TD,		// new tablecell
	HTML_ENDTD,		// end of new tablecell
	HTML_PRE,		// preformatted text
	HTML_ENDPRE,		// preformatted text
	HTML_BLOCKQUOTE,
	HTML_ENDBLOCKQUOTE,

	HTML_endOfHTMLList
} HTML_t;

@interface Text(HTMLExtensions)

- setFromHTML:(const char *)htmlString andDelete:(BOOL) doClear;

// these are private
- sharedField;
- setSharedButton:theButton;

@end


// for url support and httpd-emulation the textDelegate has to implement the following

@interface Object(HTMLTextDelegation)

// if file=="///SameFile///" then use -findMarker:markername on the current text
// otherwise you will have to parse file as an URL
- showFile:(const char *) file atMarker:(const char *) markerName openInNewWin:(BOOL) flag;

- setTitle:(const char *) aTitle;

@end

// hidden NeXT-utility class uncovered (MiscClass-decoded)
@interface NXGraphicCell : Cell
{
}

+ initialize;

- replaceGraphic: arg;
- initFromImage: theImage name: (const char *) theName;

- readRichText:  (NXStream *) theStrean forView: theView;
- writeRichText: (NXStream *) theStrean forView: theView;
- free;
- calcCellSize: (NXSize *) theSize;
- drawSelf: (NXRect *) aRect inView: theView;
- image;
- setImageNamed: (const char *) theName forView: theView;
-(BOOL) trackMouse: (NXEvent *) theEvnt inRect: (const NXRect *) drawRect ofView: theView;
- highlight: (NXRect *) aRect inView: theView lit: (BOOL) flag;

@end

@interface Text(TextWarningSuppression)
// hidden NeXT-utility method uncovered (MiscClass-decoded):
// this one selects the line of the marker spelling someSearch
- findMarker:(const char*) someSearch;
@end